#include "itext.h"
#include "xtext.h"
#include "xjp.h"
#include <time.h>

int xtext_get_string_size(Display *disp,my_window_t *win,char *euc_str,char *utf8_str,int *w,int *h,int font_type)
{
        XFontSet fs;

	switch(font_type){

		case FTYPE_JPA:fs = win->fs;break;
		case FTYPE_SMA:fs = win->fs_s;break;
		case FTYPE_RUB:fs = win->rubi_fs;break;
		case FTYPE_ENG:fs = win->fs_e;break;

		default:fs = win->fs_s;break;

	}
        if(win->anti == 0 || utf8_str == NULL){

                XRectangle ink,log;
                *w = XmbTextExtents(fs,euc_str,strlen(euc_str),&ink,&log) + 2;
                *h = log.height + 2;

        }else{

#if HAVE_LIBXFT
                XftFont *font;
                XGlyphInfo gi;
		switch(font_type){
			case FTYPE_JPA:font = win->font;break;
			case FTYPE_SMA:font = win->font_s;break;
			case FTYPE_RUB:font = win->font_rubi;break;
			case FTYPE_ENG:font = win->font_e;break;
			default:font = win->font;break;
		}
                XftTextExtentsUtf8(disp,font,(FcChar8 *)utf8_str,strlen(utf8_str),&gi);
                *w = gi.width;
                *h = gi.height;
#else
                XRectangle ink,log;
                *w = XmbTextExtents(fs,euc_str,strlen(euc_str),&ink,&log) + 2;
                *h = log.height + 2;
#endif
        }
        return 0;
}
int xtextDrawPageTitleString(	Display *disp,
				my_window_t *win,
				char *euc_str,
				char *utf8_str,
				int x,
				int y,
				int font_type		)
{
        XFontSet fs;
        GC gc;
	switch(font_type){
		case FTYPE_JPA:fs = win->fs;break;
		case FTYPE_SMA:fs = win->fs_s;break;
		case FTYPE_RUB:fs = win->rubi_fs;break;
		case FTYPE_ENG:fs = win->fs_e;break;
		default:fs = win->fs_s;break;
	}
        gc = win->gc;
        if(win->anti == 0){
                XmbDrawString(disp,win->pix0,fs,gc,x,y,euc_str,strlen(euc_str));

        }else{

#if HAVE_LIBXFT
		XftFont *font;
		switch(font_type){
			case FTYPE_JPA:font = win->font;break;
			case FTYPE_SMA:font = win->font_s;break;
			case FTYPE_RUB:font = win->font_rubi;break;
			case FTYPE_ENG:font = win->font_e;break;
			default:font = win->font;break;
		}
                XftDrawStringUtf8(win->draw,&(win->fg_color),font,x,y,(FcChar8 *)utf8_str,strlen(utf8_str));
#else
                XmbDrawString(disp,win->pix0,fs,gc,x,y,euc_str,strlen(euc_str));
#endif
        }
        return 0;
}
int xtext_Draw_Help(Display *disp,my_window_t *win,xtext_conf_t *xconf)
{
        char help_str[64];
        int x0,y0,width,height;
        int font_type;

        XClearWindow(disp,win->win);
	/*
	k_line(disp,win);
	*/
	m_mes(disp,win);
/*
        font_type = 3;
        sprintf(help_str,"%s [Ver. %s]  by aB~",XTEXT_NAME,XTEXT_VERSION);
        xtext_get_string_size(disp,win,help_str,help_str,&width,&height,font_type);
        x0 = win->width - width - 15;
	y0 = win->height - (height * 1) - 5;
        xtextDrawPageTitleString(disp,win,help_str,help_str,x0,y0,font_type);
	*/
        font_type = 3;
        strcpy(help_str,"http://xjp-text.sourceforge.jp/");
        xtext_get_string_size(disp,win,help_str,help_str,&width,&height,font_type);
        x0 = win->width - width - 5;
        y0 = win->height - 5;
        xtextDrawPageTitleString(disp,win,help_str,help_str,x0,y0,font_type);
        return 0;
}
